export interface Article {
  id: string
  type: string
  attributes: {
    title: string
    body: {
      value: string
      summary: string
    }
    created: string
    field_image?: {
      uri: {
        url: string
      }
    }
  }
  relationships: {
    field_tags?: {
      data: Array<{
        id: string
        type: string
      }>
    }
  }
}

export interface Tag {
  id: string
  type: string
  attributes: {
    name: string
  }
}

export interface ArticleFormData {
  title: string
  description: string
  content: string
  tags: string[]
} 